// ------------------------------------------------------------------------------
// DS3231 RTC functions
// ------------------------------------------------------------------------------

#ifndef DS3231_RTC_H
#define DS3231_RTC_H

#include "Arduino.h"
#include "Wire.h"

// ------------------------------------------------------------------------------
//
// Hardware definitions for A040618 RTC Module Option (see DS3231 datasheet)
//
// ------------------------------------------------------------------------------

#define DS3231_RTC 0x68       // DS3231 I2C address
#define DS3231_SECRG 0x00     // DS3231 Seconds Register
#define DS3231_STATRG 0x0F    // DS3231 Status Register

// ------------------------------------------------------------------------------

byte decToBcd( byte val );
byte bcdToDec( byte val );

byte rtcInit( void );
bool rtcIsRunning( void );
void readRTC( byte *seconds, byte *minutes, byte *hours, byte *day, byte *dow, byte *month, byte *year, byte *tempC );
void writeRTC( byte seconds, byte minutes, byte hours, byte day, byte month, byte year );

// void autoSetRTC( void );
void printDateTime( byte readSourceFlag );
void print2digit( byte data );
bool isLeapYear( uint16_t yearXX );
uint8_t dayOfWeek( uint8_t day, uint8_t month, uint16_t year );
uint8_t daysOfMonth( uint8_t month, uint16_t year );
void ChangeRTC( void );

#endif
