// ------------------------------------------------------------------------------
// MCP23017 GPIO functions
// ------------------------------------------------------------------------------

#ifndef MCP32017_GPIO_H
#define MCP32017_GPIO_H

#include "Arduino.h"
#include "Wire.h"

// ------------------------------------------------------------------------------
//
// Hardware definitions for A040618 GPE Option (Optional GPIO Expander)
//
// ------------------------------------------------------------------------------

#define GPIOEXP_ADDR 0x20    // I2C module address (see datasheet)
#define IODIRA_REG 0x00      // MCP23017 internal register IODIRA  (see datasheet) - I/O direction register A
#define IODIRB_REG 0x01      // MCP23017 internal register IODIRB  (see datasheet) - I/O direction register B
#define GPPUA_REG 0x0C       // MCP23017 internal register GPPUA  (see datasheet)  - Pull-Up resistors A
#define GPPUB_REG 0x0D       // MCP23017 internal register GPPUB  (see datasheet)  - Pull-Up resistors B
#define GPIOA_REG 0x12       // MCP23017 internal register GPIOA  (see datasheet)  - GPIO data register A
#define GPIOB_REG 0x13       // MCP23017 internal register GPIOB  (see datasheet)  - GPIO data register B

// ------------------------------------------------------------------------------

byte gpioInit( void );
void gpioWrite( byte port, byte data );

#endif